from ..abstract_parts import *

from .JlcPart import JlcPart
from .JlcBlackbox import KiCadJlcBlackbox

from .GenericResistor import ESeriesResistor, GenericChipResistor, GenericAxialResistor, GenericAxialVerticalResistor
from .JlcResistor import JlcResistor
from .JlcResistorArray import JlcResistorArray
from .GenericCapacitor import GenericMlcc
from .JlcCapacitor import JlcCapacitor
from .JlcElectrolyticCapacitor import JlcAluminumCapacitor
from .JlcInductor import JlcInductor
from .JlcFerriteBead import JlcFerriteBead
from .Leds import SmtLed, ThtLed, Smt0606RgbLed, Smt0404RgbLed, ThtRgbLed
from .JlcLed import JlcLed
from .JlcDiode import JlcDiode, JlcZenerDiode
from .JlcBjt import JlcBjt
from .JlcFet import JlcFet, JlcSwitchFet
from .CustomDiode import CustomDiode
from .CustomFet import CustomFet
from .Batteries import Cr2032, Li18650, AABattery
from .Switches import SmtSwitch, SmtSwitchRa, KailhSocket
from .RotaryEncoder_Alps import Ec11eWithSwitch, Ec11j15WithSwitch, Ec05e
from .RotaryEncoder_Bourns import Pec11s
from .DirectionSwitch_Alps import Skrh
from .JlcCrystal import JlcCrystal
from .JlcOscillator import JlcOscillator
from .JlcSwitches import JlcSwitch, Skrtlae010
from .JlcPptcFuse import JlcPptcFuse
from .JlcAntenna import JlcAntenna
from .Speakers import Speaker, ConnectorSpeaker
from .SpeakerDriver_Analog import Lm4871, Tpa2005d1, Pam8302a
from .SpeakerDriver_Max98357a import Max98357a
from .Microphone_Sd18ob261 import Sd18ob261
from .Opamp_Mcp6001 import Mcp6001
from .Opamp_Tlv9061 import Tlv9061
from .Opamp_Tlv915x import Tlv9152
from .Opamp_Opax171 import Opa2171
from .Opamp_Opax197 import Opa197, Opa2197
from .Opamp_Opax189 import Opa189, Opa2189
from .Opamp_Opax333 import Opa2333
from .Opamp_Lmv321 import Lmv321
from .CeramicResonator_Cstne import Cstne

from .PassiveConnector_Header import PinHeader254, PinHeader254Vertical, PinHeader254Horizontal, PinSocket254
from .PassiveConnector_Header import PinHeader254DualShroudedInline
from .PassiveConnector_Header import PinHeader127DualShrouded
from .PassiveConnector_Header import JstPhKVertical, JstPhSmVertical, JstPhKHorizontal, JstPhSmVerticalJlc, \
    JstShSmHorizontal, MolexSl
from .PassiveConnector_Fpc import Fpc030, Fpc030Top, Fpc030Bottom, Fpc030TopBottom, HiroseFh35cshw
from .PassiveConnector_Fpc import Fpc050, Fpc050Top, Fpc050Bottom, Fpc050BottomFlip, HiroseFh12sh, Afc01, Afc07Top, Te1734839
from .PassiveConnector_TagConnect import TagConnect, TagConnectLegged, TagConnectNonLegged

from .Jumpers import SolderJumperTriangular

from .DebugHeaders import SwdCortexTargetHeader
from .DebugHeaders import SwdCortexTargetTc2050, SwdCortexTargetTagConnect, SwdCortexTargetTc2050
from .SdCards import SdCard, SdSocket, MicroSdSocket, Dm3btDsfPejs, Molex1040310811

from .LinearRegulators import Ld1117, Ldl1117, Ap2204k, Ap7215, Xc6206p, Xc6209, Ap2210, Lp5907, L78l
from .VoltageReferences import Ref30xx
from .BuckConverter_TexasInstruments import Tps561201, Tps54202h
from .BuckConverter_Ap3418 import Ap3418
from .BoostConverter_AnalogDevices import Ltc3429
from .BoostConverter_DiodesInc import Ap3012
from .BoostConverter_Torex import Xc9142
from .BoostConverter_TexasInstruments import Tps61040, Lm2733
from .SwitchedCap_TexasInstruments import Lm2664
from .BuckConverter_Custom import CustomSyncBuckConverterIndependent
from .BuckBoostConverter_Custom import CustomSyncBuckBoostConverterPwm
from .PowerConditioning import BufferedSupply, Supercap, SingleDiodePowerMerge, DiodePowerMerge, PriorityPowerOr, SoftPowerGate, SoftPowerSwitch, PmosReverseProtection, PmosChargerReverseProtection
from .LedDriver_Al8861 import Al8861
from .ResetGenerator_Apx803s import Apx803s
from .BootstrapVoltageAdder import BootstrapVoltageAdder

from .Microcontroller_Lpc1549 import Lpc1549_48, Lpc1549_64
from .Microcontroller_Stm32f103 import Stm32f103_48
from .Microcontroller_Stm32f303 import Nucleo_F303k8
from .Microcontroller_Stm32g031 import Stm32g031_G
from .Microcontroller_Stm32l432 import Stm32l432k
from .Microcontroller_nRF52840 import Holyiot_18010, Mdbt50q_1mv2, Feather_Nrf52840
from .Microcontroller_Esp import EspProgrammingHeader, EspProgrammingAutoReset, EspProgrammingPinHeader254, EspProgrammingTc2030
from .Microcontroller_Esp import HasEspProgramming
from .Microcontroller_Esp import EspAutoProgram
from .Microcontroller_Esp32 import Esp32_Wroom_32, Freenove_Esp32_Wrover
from .Microcontroller_Esp32s3 import Esp32s3_Wroom_1, Freenove_Esp32s3_Wroom
from .Microcontroller_Esp32c3 import Esp32c3_Wroom02, Esp32c3, Xiao_Esp32c3
from .Microcontroller_Rp2040 import Rp2040, Xiao_Rp2040
from .Fpga_Ice40up import Ice40up5k_Sg48

from .IoExpander_Pcf8574 import Pcf8574
from .IoExpander_Pca9554 import Pca9554

from .Connectors import PowerBarrelJack, Pj_102ah, Pj_036ah, LipoConnector, QwiicTarget
from .FanConnector import CpuFanConnector, CpuFanPwmControl
from .CanBlocks import Pesd1can
from .UsbPorts import UsbAReceptacle, UsbCReceptacle, UsbAPlugPads, UsbMicroBReceptacle
from .UsbPorts import Tpd2e009, Pesd5v0x1bt, Pgb102st23
from .Fusb302b import Fusb302b
from .Connector_Banana import Ct3151, Fcr7350
from .Connector_Rf import Bwipx_1_001e

from .TestPoint_Keystone import Keystone5015, CompactKeystone5015, Keystone5000
from .TestPoint_Rc import TeRc

from .AdcSpi_Mcp3201 import Mcp3201
from .AdcSpi_Mcp3561 import Mcp3561
from .DacSpi_Mcp4901 import Mcp4921
from .DacI2c_Mcp47f import Mcp47f
from .DacI2c_Mcp4728 import Mcp4728

from .Rtc_Pcf2129 import Pcf2129
from .RfModules import Xbee_S3b, BlueSmirf
from .Neopixel import Neopixel, Ws2812b, Sk6812Mini_E, Sk6805_Ec15, Sk6812_Side_A, NeopixelArray, NeopixelArrayCircular
from .Lcd_Qt096t_if09 import Qt096t_if09
from .Oled_Er_Oled_091_3 import Er_Oled_091_3
from .Oled_Er_Oled_096_1_1 import Er_Oled_096_1_1
from .Oled_Er_Oled_096_1c import Er_Oled_096_1c
from .Oled_Er_Oled_022 import Er_Oled022_1
from .Oled_Er_Oled_028 import Er_Oled028_1
from .Oled_Nhd_312_25664uc import Nhd_312_25664uc
from .EInk_E2154fs091 import E2154fs091
from .EInk_Er_Epd027_2 import Er_Epd027_2
from .EInk_WaveshareDriver import Waveshare_Epd
from .SolidStateRelay_G3VM_61GR2 import G3VM_61GR2
from .SolidStateRelay_Toshiba import Tlp3545a
from .AnalogSwitch_Nlas4157 import Nlas4157
from .AnalogSwitch_Dg468 import Dg468
from .CanTransceiver_Iso1050 import Iso1050dub
from .CanTransceiver_Sn65hvd230 import Sn65hvd230
from .CurrentSense_Ad8418 import Ad8418a
from .BatteryProtector_S8261A import S8261A
from .BatteryCharger_Mcp73831 import Mcp73831
from .Distance_Vl53l0x import Vl53l0xBase, Vl53l0x, Vl53l0xConnector, Vl53l0xArray
from .Isolator_Cbmud1200 import Cbmud1200l
from .GateDriver_Ir2301 import Ir2301
from .GateDriver_Ucc27282 import Ucc27282
from .GateDriver_Ncp3420 import Ncp3420
from .SpiMemory_W25q import W25q
from .SpiMemory_93Lc import E93Lc_B
from .UsbUart_Cp2102 import Cp2102
from .UsbInterface_Ft232h import Ft232hl
from .Logic_74Ahct import L74Ahct1g125
from .Logic_74Lvc import Sn74lvc1g74
from .Comparator_Lmv331 import Lmv331
from .Camera_Ov2640_Fpc24 import Ov2640, Ov2640_Fpc24

from .Labels import DuckLogo, LeadFreeIndicator, IdDots4, LemurLogo
from .Mechanicals import Outline_Pn1332
from .Mechanicals import MountingHole, MountingHole_M2_5, MountingHole_M3, MountingHole_M4, MountingHole_NoPad_M2_5

from .MotorDriver_L293dd import L293dd
from .MotorDriver_Drv8833 import Drv8833
from .Bldc_Drv8313 import Drv8313

from .Imu_Lsm6ds3trc import Lsm6ds3trc
from .Mag_Qmc5883l import Qmc5883l
from .EnvironmentalSensor_Sensirion import Shtc3
from .EnvironmentalSensor_Bme680 import Bme680
from .EnvironmentalSensor_Ti import Hdc1080, Tmp1075n
from .LightSensor_Bh1750 import Bh1750
from .LightSensor_As7341 import As7341

from .LedMatrix import CharlieplexedLedMatrix
from .SwitchMatrix import SwitchMatrix
from .ResistiveSensor import ConnectorResistiveSensor

from .Jacdac import JacdacDataPort, JacdacPassivePort
from .Jacdac import JacdacEdgeConnector, JacdacDataInterface, Rclamp0521p
from .Jacdac import JacdacMountingData1, JacdacMountingGnd2, JacdacMountingGnd4, JacdacMountingPwr3
from .Jacdac import JacdacDeviceTop


# compatibility shims
import deprecated as __deprecated  # not to be exported

@__deprecated.deprecated("new naming convention")
class Vl53l0xApplication(Vl53l0x, DeprecatedBlock):
    pass

@__deprecated.deprecated("new naming convention")
class Imu_Lsm6ds3trc(Lsm6ds3trc, DeprecatedBlock):
    pass

@__deprecated.deprecated("new naming convention")
class Mag_Qmc5883l(Qmc5883l, DeprecatedBlock):
    pass
